## metview 5.21.2

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.12.0 FATAL_ERROR )

include( ${INCLUDE_CONFIG}-local-config.cmake OPTIONAL )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
#set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}" )


project( MetviewMiniBundle VERSION 5.21.2 LANGUAGES C CXX )
set(CPACK_PACKAGE_NAME Metview)  # so that the source tarball will have the name 'Metview'


# list all the packages we incorporate into the bundle
set(MV_BUNDLE_PACKAGES METVIEW MARS_CLIENT MIR ATLAS ECKIT)

if(METVIEW_SITE STREQUAL ecmwf )
    #list(APPEND MV_BUNDLE_PACKAGES FDB)
endif()

# create a variabe for each package we bundle
foreach (bunpack ${MV_BUNDLE_PACKAGES})
    set(MV_BUNDLE_CONTAINS_${bunpack} 1)
endforeach()


# -------------------------------------------------------------------------------------
# settings which are required across the packages to get a working Metview installation

#general
set(ENABLE_ODB           OFF CACHE BOOL "ODB support")
set(ENABLE_EXPERIMENTAL  OFF CACHE BOOL "Experimental features")
set(ENABLE_FORTRAN       NOT_SET CACHE BOOL "Fortran features")

#mars
set(ECMWF             OFF CACHE BOOL "build the client as for ECMWF")
set(CONFIG_FDB        OFF CACHE BOOL "database configuration to access FDB")
set(ENABLE_UDP_STATS  OFF CACHE BOOL "")
set(ENABLE_MPI        OFF CACHE BOOL "")
set(ENABLE_BUILD_TOOLS  OFF   CACHE BOOL   "")


# if the user did bot supply a value for ENABLE_FORTRAN, then unset it
# (we want to then use the default behaviour, per package)
if(ENABLE_FORTRAN STREQUAL "NOT_SET")
    unset(ENABLE_FORTRAN)
    unset(ENABLE_FORTRAN CACHE)
endif()


# -------------------------------------------------------------------------------------

macro(my_bundle_pkg)
    ecbuild_bundle( ${ARGV} )
endmacro()

include( ecbuild_bundle )

ecbuild_bundle_initialize()

    ecbuild_add_option( FEATURE EXPOSE_SUBPACKAGES
                        DEFAULT OFF
                        DESCRIPTION "Allow separate use of the sub-packages in the bundle")



    # if the installer does not want to expose the sub-packages then we need to:
    # a) change $PREFIX so that everything is installed into a sub-directory
    # b) change the location of the Metview startup script so it's installed
    #    where intended (Metview takes care of this)

    if (NOT ENABLE_EXPOSE_SUBPACKAGES)
        set(ORIGINAL_CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
        set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/lib/metview-bundle")
    endif()


    if(MV_BUNDLE_CONTAINS_FDB)
        set( FDB_CONF_FILE /usr/local/apps/fdb/etc/Config )
        list(APPEND MV_BUNDLE_PACKAGES FDB)
        ecbuild_bundle( PROJECT fdb                GIT "ssh://git@git.ecmwf.int/mars/fdb_vintage"    TAG  4.11.0   )
    else()
        set(FDB_DIR "/dummy/path/for/bundle")
    endif()

    my_bundle_pkg( PROJECT eckit        GIT "ssh://git@git.ecmwf.int/ecsdk/eckit"       TAG  1.25.2   )
    my_bundle_pkg( PROJECT atlas        GIT "ssh://git@git.ecmwf.int/atlas/atlas"       TAG  0.36.0   )
    my_bundle_pkg( PROJECT mir          GIT "ssh://git@git.ecmwf.int/mir/mir"           TAG  1.19.1   )
    my_bundle_pkg( PROJECT mars-client  GIT "ssh://git@git.ecmwf.int/mars/mars-client"  TAG  6.33.17  )
    my_bundle_pkg( PROJECT metview      GIT "ssh://git@git.ecmwf.int/metv/metview"      TAG  5.21.2   )

    ecbuild_dont_pack(FILES configure.sh;ecmwf;make-tarball.sh;test-tarball.sh;configure.clang.sh;bamboo)

ecbuild_bundle_finalize()


ecbuild_info("ENABLE_EXPOSE_SUBPACKAGES is ${ENABLE_EXPOSE_SUBPACKAGES}:")
if (ENABLE_EXPOSE_SUBPACKAGES)
    ecbuild_info("All packages in the bundle will be installed at the same level into:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
else()
    ecbuild_info("All packages in the bundle will be installed into a sub-directory:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
    ecbuild_info ("The Metview startup script will be installed into:")
    ecbuild_info("  ${ORIGINAL_CMAKE_INSTALL_PREFIX}/bin")
endif()

=== mars-client/src/CMakeLists.txt ===
### config headers

# if we are not building inside the mars-client-bundle we won't have this defined
if(NOT DEFINED MARSCLIENT_VERSION_STR )
  set(MARSCLIENT_VERSION_STR ${MARS_CLIENT_VERSION_STR})
endif()

configure_file( mars_client_version.h.in  mars_client_version.h )
configure_file( mars_client_version.c.in  mars_client_version.c )

# compile definitions

ecbuild_generate_config_headers()

configure_file( mars_client_config.h.in    mars_client_config.h   )

# install generated headers

install(FILES
			${CMAKE_CURRENT_BINARY_DIR}/mars_client_version.h
			${CMAKE_CURRENT_BINARY_DIR}/mars_client_config.h
		DESTINATION
			${INSTALL_INCLUDE_DIR}/marsclient )

add_definitions( -DR64 )

if( ECMWF )
    add_definitions( -DECMWF )
endif()

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
	message( STATUS "System is big endian" )
else()
	message( STATUS "System is little endian" )
	add_definitions(-DLITTLE_END)
endif()

if( NOT HAVE_FDB )
    add_definitions(-DNOFDB)
endif()

if( NOT HAVE_FDB5 )
    add_definitions(-DNOFDB5)
endif()

if( NOT HAVE_ODB )
	add_definitions(-DNOODB)
else()
	add_definitions(-DODB_SUPPORT )
	include_directories( ${ODB_API_INCLUDE_DIRS} ${ECKIT_INCLUDE_DIRS} )
endif()

if( HAVE_PPROC_EMOS )
    list( APPEND mars_client_src_files pproc_emos.cc )
endif()

if( HAVE_PPROC_MIR )
    list( APPEND mars_client_src_files pproc_mir.cc )
endif()

if( NOT HAVE_CURL )
	add_definitions(-DNOCURL)
endif()

if(HAVE_ECMWF_DEVELOPMENT)
  add_definitions(-DECMWF)
  add_definitions(-DNOEMS)
  add_definitions(-DNOAUTH)
  add_definitions(-DNOSCHEDULE)
endif()

# sources

list( APPEND mars_client_src_files
account.c
archive.c
authenticate.c
base.c
bufr.c
calc.c
certify.c
check.c
control.c
cos.c
ecaccess.c
eccert.c
environ.c
expand.c
extargs.c
externf.c
fdb5base.cc
forwardbase.c
feedtask.c
field.c
filebase.c
files.c
flatfilebase.c
free.c
gribbase.c
grib.c
guess.c
handler.c
hash.c
hidden.c
hypercube.c
ibmblk.c
index.c
langy.c
list.c
lock.c
logfile.c
mcs.c
memory.c
dhsbase.c
metadata.c
msbase.c
multibase.c
netbase.c
netcdf.c
hdf5.c
nfdbbase.c
nullbase.c
options.c
pproc.h
pproc.cc
pproc_none.cc
queue.c
rdb.c
remove.c
request.c
restricted.c
retrieve.c
schedule.c
server.c
service.c
sh2ll.c
statistics.c
stream.c
target.c
tcp.c
proxies.c
time.c
timer.c
tools.c
udp.c
variable.c
version.c
json.c
api.c
apibase.c
wind.c)

if(HAVE_UDP_STATS)
  list(APPEND mars_client_src_files udp_statistics.cc)
endif()

if(HAVE_NETCDF)

  list(APPEND mars_client_src_files
    nctarget.c
    nctypes.c
    ncschema.c
    ncmerge.c
    )

endif()

if(HAVE_ODB)
    list(APPEND mars_client_src_files
        odb.cc
    )
endif()

ecbuild_find_lexyacc()
if(FLEX_FOUND)
    set(_lex ${FLEX_EXECUTABLE})
elseif(LEX_FOUND)
    set(_lex ${LEX_EXECUTABLE})
else()
    ecbuild_critical("Found neither flex nor lex")
endif()

if(YACC_FOUND)
    set(_yacc ${YACC_EXECUTABLE})
elseif(BISON_FOUND)
    set(_yacc ${BISON_EXECUTABLE} -y)
else()
    ecbuild_critical("Found neither yacc nor bison")
endif()

if(mars_client_HAVE_RPC)

  list( APPEND mars_client_src_files marsxdr.c )
  list( APPEND mars_client_deps marsxdr )

  if( DEFINED RPCGEN_PATH )
      find_program( RPCGEN_EXECUTABLE NAMES rpcgen PATHS ${RPCGEN_PATH} PATH_SUFFIXES bin NO_DEFAULT_PATH )
  endif()
  find_program( RPCGEN_EXECUTABLE NAMES rpcgen )
  if( NOT RPCGEN_EXECUTABLE )
    ecbuild_critical("Could not find rpcgen. Please provide RPCGEN_PATH.")
  endif()

  # targets

  configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/rpcmars.x ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x COPYONLY )

  add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
      COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
      COMMAND ${RPCGEN_EXECUTABLE} -h -o ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x )

  add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c
      COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c
      COMMAND ${RPCGEN_EXECUTABLE} -c -o ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x )

  add_custom_target(marsxdr DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c)

  list(APPEND _make_cleans rpcmars.h marsxdr.c )

endif()

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langl.c
	  COMMAND ${_lex} -l ${CMAKE_CURRENT_SOURCE_DIR}/langl.l\; sed -e s/yy/yy_mars/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/langl.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/langl.l)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langy.c
	  COMMAND ${_yacc} -t ${CMAKE_CURRENT_SOURCE_DIR}/langy.y\; sed -e s/yy/yy_mars/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/langy.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/langy.y)

list(APPEND _make_cleans langl.c langy.c )

add_custom_target(marslex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/langy.c ${CMAKE_CURRENT_BINARY_DIR}/langl.c)
list( APPEND mars_client_deps marslex)

set_directory_properties( ADDITIONAL_MAKE_CLEAN_FILES  ${_make_cleans} )

set( grib_handling_pkg eccodes )

set(MARSC_HEADER_FILES_TO_INSTALL
        api.h
        base.h
        bufr.h
        control.h
        cos.h
        field.h
        globals.h
        grib.h
        hypercube.h
        index.h
        json.h
        lang.h
        mars.h
        nctarget.h
        proto.h
        hash.h
        tools.h
        variable.h
)

if(mars_client_HAVE_RPC)
  list(APPEND MARSC_HEADER_FILES_TO_INSTALL ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h)
endif()

ecbuild_add_library(
  TARGET      marsclient
  GENERATED   mars_client_version.c
  INSTALL_HEADERS_LIST ${MARSC_HEADER_FILES_TO_INSTALL}
  HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/marsclient

	SOURCES
      ${mars_client_src_files}
      mars_client_version.c
	DEPENDS
      ${mars_client_deps}

  PUBLIC_INCLUDES
       $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
       $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
       ${RPC_INCLUDE_DIRS}

  PRIVATE_INCLUDES
        ${ECKIT_INCLUDE_DIRS}
        ${MARS_SERVER_INCLUDE_DIRS}
        ${FDB5_INCLUDE_DIRS}
        ${MIR_INCLUDE_DIRS}
        ${CURL_INCLUDE_DIRS}

  PUBLIC_LIBS
        eccodes
        ${RPC_LIBRARIES}

  PRIVATE_LIBS
        ${FDB5_LIBRARIES}
        ${MARS_FEATURE_LIBRARIES}
        ${CURL_LIBRARIES}
        ${CMATH_LIBRARIES}
        ${CMAKE_THREAD_LIBS_INIT}
)

set(_marsbin_noinstall NOINSTALL) # still needed for the tests
if(HAVE_BUILD_TOOLS)
  set(_marsbin_noinstall)
endif()
ecbuild_add_executable(
    TARGET    mars.bin
    INCLUDES  ${MIR_INCLUDE_DIRS} ${LIBEMOS_INCLUDE_DIRS}
    SOURCES   mars.c
    LIBS      marsclient ${MARS_FEATURE_LIBRARIES}
    ${_marsbin_noinstall}
)

ecbuild_add_executable(
    NOINSTALL
    TARGET    test-udp-stats
    SOURCES   test-udp-stats.c
    CONDITION HAVE_UDP_STATS
    LIBS      marsclient
)

if(HAVE_BUILD_TOOLS)
  add_subdirectory( tools )
endif()

=== mars-client/tests/CMakeLists.txt ===
find_program( GRIB_COMPARE grib_compare )
find_program( GRIB_LS      grib_ls )

if( NOT GRIB_COMPARE AND TARGET grib_compare )
    set( GRIB_COMPARE "$<TARGET_FILE:grib_compare>" )
    set( GRIB_COMPARE "$<TARGET_FILE:grib_ls>" )
endif()

ecbuild_add_test(
    TARGET test_${V}_${T}
    ENABLED OFF
    TYPE SCRIPT
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test_${V}
    ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${V}/${R}
)

if( GRIB_COMPARE )
    message( STATUS "tests will use grib_compare: ${GRIB_COMPARE}" )
else()
    message( WARNING "Could not find grib_compare executable -- turning off ${PROJECT_NAME} tests!\nTo enable them place 'grib_compare' on the PATH and re-run cmake" )
endif()

# define the grib environment

set( grib_handling_pkg eccodes )

set( GRIB_DEFINITION_PATH ${eccodes_BASE_DIR}/share/eccodes/definitions/ )
set( GRIB_SAMPLES_PATH    ${eccodes_BASE_DIR}/share/eccodes/samples/ )

set( mars_new_binary "$<TARGET_FILE:mars.bin>" )

ecbuild_configure_file( run_mars.sh.in ${CMAKE_CURRENT_BINARY_DIR}/run_mars.sh @ONLY )

# mars ems permissions
set( USER $ENV{USER} )
ecbuild_configure_file( ems_cache_prod.in ${CMAKE_CURRENT_BINARY_DIR}/ems_cache_prod @ONLY )

#### TESTS

# To add a test, just add the mars request with a .req extension
# and make sure the target=testdata which automatically gets substituted to testdata.prod and testdata.test

list( APPEND _test_reqs
compute.req
interpolation_wave.req
interpolation_gaussian.req
interpolation_l137.req
interpolation_rgg2ll.req
#interpolation_t1279_gg.req  # Creates very large coefficient file
#interpolation_t1279_sh.req  # Creates very large coefficient file
#interpolation_rotated.req   # Failing in ECMWF bundle with Intel
# interpolation_latlon.req   # comparison data no longer correct
# interpolation_sh2ll.req    # comparison data no longer correct
transform_vod2uv.req
retrieve_oper.req
retrieve_enfo.req
#retrieve_ocean.req  # MIR doesn't support GRIB localDefinitionNumber=4
retrieve_fdb_uv_pl.req
retrieve_fdb_uv_ml.req
# retrieve_ai.req
# retrieve_tigge.req
MARSC-94.req
# MARSC-100.001.req
# MARSC-100.002.req
)

if(HAVE_ODB)
    list( APPEND _test_reqs
        #odb_filter_updated.req       # As a result of ODB-159 the default codec has changed from short_real to short_real2
        # odb_filter_odc.req            # ODC removed the unused Flags entries
        )
endif()

if(eccodes_HAVE_JPG)
    list( APPEND _test_reqs MARSC-86.req ) # contains jpeg-encoded data
endif()

foreach( t ${_test_reqs} )
    list( APPEND _test_data ${t}.refdata.mir ${t}.inpdata )
endforeach()

ecbuild_get_test_multidata( TARGET get_configs NAMES mars-client-test-configs.tar.gz:15bfc319ff03a6db165f1096cc468fd8 EXTRACT )

ecbuild_get_test_multidata( TARGET get_data NAMES ${_test_data} )

ecbuild_add_resources( TARGET tests_run_mars SOURCES_PACK ${_test_reqs} )

set( MIR_HOME ${CMAKE_CURRENT_BINARY_DIR} )
if( EXISTS "${CMAKE_BINARY_DIR}/etc/mir/config.yaml" )  # for bundles
    set( MIR_HOME ${CMAKE_BINARY_DIR} )
elseif( EXISTS "${mir_BASE_DIR}/etc/mir/config.yaml" )  # for individual packages
    set( MIR_HOME ${mir_BASE_DIR} )
endif()

foreach( _req ${_test_reqs} )

    string(REGEX REPLACE "[^A-Za-z0-9]" "_" _tst ${_req})

    ecbuild_add_test(
        TARGET test_${_tst}
        TYPE SCRIPT
        COMMAND ${CMAKE_CURRENT_BINARY_DIR}/run_mars.sh
        ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${_req}
        TEST_DEPENDS get_data get_configs
        ENVIRONMENT
            TESTS_DIR=${CMAKE_CURRENT_BINARY_DIR}
            MARS_HOME=${CMAKE_CURRENT_BINARY_DIR}
            MARS_PPROC_BACKEND=MIR
            MIR_HOME=${MIR_HOME}
    )

endforeach()

=== metview/contrib/CMakeLists.txt ===

# create a list of sub-directories
file(GLOB subs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*)
set(dirlist "")
foreach(sub ${subs})
    if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${sub})
        list(APPEND dirlist ${sub})
    endif()
endforeach()


# go into each sub-directory
foreach(subdir ${dirlist})
    add_subdirectory(${subdir})
endforeach()


# propagate ModuleObjectSpecFiles to the parent scope so we can use it again
set(ModuleObjectSpecFiles ${ModuleObjectSpecFiles} PARENT_SCOPE)
set(ModuleXpmFiles        ${ModuleXpmFiles}        PARENT_SCOPE)
set(ModuleSvgFiles        ${ModuleSvgFiles}        PARENT_SCOPE)

=== metview/src/DebugTools/CMakeLists.txt ===


if(METVIEW_QT5)
 QT5_WRAP_CPP(XServ_MOC XServ.h)
elseif(METVIEW_QT6)
 QT6_WRAP_CPP(XServ_MOC XServ.h)
endif()


set(xserv_srcs
    XServ.cc XServ.h  ${XServ_MOC}
)


ecbuild_add_executable( TARGET       xserv
                        SOURCES      ${xserv_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${METVIEW_QT_LIBRARIES}
                    )


if(METVIEW_QT5)
 QT5_WRAP_CPP(MvMonitor_MOC ProcMonitor.h)
elseif(METVIEW_QT6)
 QT6_WRAP_CPP(MvMonitor_MOC ProcMonitor.h)
endif()


set(MvMonitor_srcs
    MvMainMonitor.cc ProcMonitor.cc MvProcNode.cc MvQProcModel.cc
    MvProcNode.h MvQProcModel.h ${MvMonitor_MOC}
)


ecbuild_add_executable( TARGET       MvMonitor
                        SOURCES      ${MvMonitor_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )

=== metview/src/Stvl/CMakeLists.txt ===

ecbuild_add_executable(
    TARGET       Stvl
    SOURCES      Stvl.cc
    DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
    INCLUDES     ${METVIEW_STANDARD_INCLUDES}
    LIBS         ${STANDARD_METVIEW_LIBS} )


metview_module_files(
    ETC_FILES  ObjectSpec.Stvl StvlDef StvlRules
    SVG_FILES  STVL.svg )

=== metview/src/codes_ui/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.12.0 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_CURRENT_SOURCE_DIR}/../../../ecbuild)

project( codes_ui LANGUAGES C CXX VERSION 1.8.0 )

set(BUILD_WITHIN_METVIEW ${ENABLE_CODES_UI})

remove_definitions(-DMETVIEW)

if (BUILD_WITHIN_METVIEW)
    set(CODES_UI_INSTALL_BIN_SUBDIR "bin/metview_bin")
    set(CODES_UI_BUILD_WITHIN_METVIEW "true")
else()
    set(CODES_UI_INSTALL_BIN_SUBDIR "bin")
    set(CODES_UI_BUILD_WITHIN_METVIEW "false")
endif()


# All executables and scripts apart from the startup script should go into MV_BIN_DIR.
# Users can override by setting METVIEW_INSTALL_EXE_BIN_DIR.
# It should be relative to the root of the install directory.
#if(DEFINED METVIEW_INSTALL_EXE_BIN_DIR)
#    set(MV_BIN_DIR ${METVIEW_INSTALL_EXE_BIN_DIR})
#else()
#    set(MV_BIN_DIR bin/metview_bin)
#endif()

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake"  "${CMAKE_CURRENT_SOURCE_DIR}/../../../ecbuild/cmake")
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE OFF)

#set(METVIEW_INSTALL_BIN_DIR "${MV_BIN_DIR}" CACHE PATH "Metview installation directory for executable files")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.9 )
set (CMAKE_CXX_STANDARD 17)

###############################################################################
# some options of this project

option( ENABLE_QT_DEBUG      "enable Qt debugging messages"                       OFF )

###############################################################################

#C check if it is an exeternal build (outside the metview source)
set(__external_build  1)
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../AppMod")
   set(__external_build 0)
endif()

# ensure we can add non-existent dependencies - required for generating icon files
if( ${CMAKE_VERSION} VERSION_GREATER "2.9.9" )
    cmake_policy(SET CMP0046 OLD)
endif()


# default startup script name
if(NOT DEFINED CODES_UI_SCRIPT )
    set( CODES_UI_SCRIPT "codes_ui" )
endif()

set(FULL_STARTUP_SCRIPT_PATH ${CMAKE_BINARY_DIR}/bin/${CODES_UI_SCRIPT})

# ensure we don't build shared libraries
if (NOT BUILD_WITHIN_METVIEW)
    set(BUILD_SHARED_LIBS OFF)
endif()

message("CMAKE_BINARY_DIR = ${CMAKE_BINARY_DIR}")
message("CMAKE_CURRENT_SOURCE_DIR = ${CMAKE_CURRENT_SOURCE_DIR}")


###############################################################################
# local project requirements

#ecbuild_add_option( FEATURE ECCODES DESCRIPTION "" DEFAULT OFF )

if (NOT BUILD_WITHIN_METVIEW)
    ecbuild_find_package(NAME eccodes VERSION 2.19.0 REQUIRED)
    set( GRIB_API_INCLUDE_DIRS ${eccodes_INCLUDE_DIRS} )
    set( GRIB_API_LIBRARIES    ${eccodes_LIBRARIES} )
    set( GRIB_API_DEFINITIONS  ${eccodes_DEFINITIONS} )
    set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
    add_definitions(-DGRIB_HANDLING_PACKAGE=ecCodes)
else()
    set(GRIB_API_PATH )
endif()

ecbuild_declare_project()

###############################################################################
# Find external dependencies

if (NOT BUILD_WITHIN_METVIEW)

    find_package(Qt6Widgets)
    if( Qt6Widgets_FOUND )
        find_package(Qt6Core5Compat      REQUIRED)
        find_package(Qt6Widgets      REQUIRED)
        find_package(Qt6Gui          REQUIRED)
        find_package(Qt6Xml          REQUIRED)
        find_package(Qt6Network      REQUIRED)
        find_package(Qt6Svg          REQUIRED)
        find_package(Qt6SvgWidgets   REQUIRED)
        ecbuild_debug("Qt6 version ${Qt6Widgets_VERSION_STRING} was found")
        include_directories(${Qt6Core5Compat_INCLUDE_DIRS} ${Qt6Widgets_INCLUDE_DIRS} ${Qt6Gui_INCLUDE_DIRS} ${Qt6Xml_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS} ${Qt6Svg_INCLUDE_DIRS} ${Qt6SvgWidgets_INCLUDE_DIRS})
        set( METVIEW_QT 1)
        set( METVIEW_QT6 true)
        add_definitions( -DMETVIEW_QT6 )
    else()
        find_package(Qt5Widgets)
        if( Qt5Widgets_FOUND )
            find_package(Qt5Gui REQUIRED)
            find_package(Qt5Network      REQUIRED)
            find_package(Qt5Xml          REQUIRED)
            find_package(Qt5XmlPatterns  REQUIRED)
            find_package(Qt5Svg          REQUIRED)
            ecbuild_debug("Qt5 version ${Qt5Widgets_VERSION_STRING} was found")
            include_directories(${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5XmlPatterns_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Svg_INCLUDE_DIRS})
            set( METVIEW_QT 1)
            set( METVIEW_QT5 true)
            add_definitions( -DMETVIEW_QT5 )
        else()
            ecbuild_critical("Neither Qt5 nor Qt6 were found ...")
        endif()
    endif()

    if( NOT ENABLE_QT_DEBUG )
        add_definitions( -DQT_NO_DEBUG_OUTPUT )
    endif()
endif()

###############################################################################
# contents
######set( METVIEW_TPLS grib_api odb_api EXPAT NetCDF PangoCairo Proj4 libemos)

#When we build outside the ecmwf dev environment (i.e. from the tarball) we have
#a different directory structure.
if(__external_build)
    set(SRC_PATH ${CMAKE_CURRENT_SOURCE_DIR}/src)
    set(SHARE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/share/codes_ui/etc)
    set(STARTUP_SCRIPT_TEMPLATE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/scripts/codes_ui_base.in")
    set(WINDOWS_STARTUP_SCRIPT_PATH "${CMAKE_CURRENT_SOURCE_DIR}/codes_ui.bat")
    set(KEYPROFILE_PATH ${SHARE_PATH})
    set(VERSION_PATH ${SHARE_PATH})
    set(IMAGE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/share/codes_ui/etc/images)
    set(EXE_SRC_PATH ${CMAKE_CURRENT_SOURCE_DIR}/src/codes_ui)
    set(LIBCODESUI_SRC_PATH "${SRC_PATH}/libCodesUi")
else()
    set(SRC_PATH "..")
    set(SHARE_PATH "../../share/metview/app-defaults")
    set(STARTUP_SCRIPT_TEMPLATE_PATH "codes_ui_base.in")
    set(WINDOWS_STARTUP_SCRIPT_PATH "codes_ui.bat")
    set(KEYPROFILE_PATH ".")
    set(VERSION_PATH ".")
    set(IMAGE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../share/metview/app-defaults/images)
    set(EXE_SRC_PATH ".")
    set(LIBCODESUI_SRC_PATH ".")
endif()

message(STATUS "CODES_UI __external_build=${__external_build}")
message(STATUS "CODES_UI BUILD_WITHIN_METVIEW=${BUILD_WITHIN_METVIEW}")


set( METVIEW_STANDARD_INCLUDE_DIRS        
        ${SRC_PATH}/libFTimeUtil
        ${SRC_PATH}/libMetview
        ${LIBCODESUI_SRC_PATH}
        ${SRC_PATH}/BufrExaminer
        ${SRC_PATH}/GribExaminer
        .
       )
set(STANDARD_METVIEW_LIBS MetviewCUI FTimeUtilCUI CodesUi)


set(METVIEW_EXTRA_LIBRARIES eccodes)

set (METVIEW_QT_INCLUDE_DIRS "")
set (METVIEW_QT_LIBRARIES "")
if( METVIEW_QT5)
    list( APPEND METVIEW_QT_INCLUDE_DIRS ${Qt5Widgets_INCLUDE_DIR} ${Qt5Gui_INCLUDE_DIR} ${Qt5Xml_INCLUDE_DIR} ${Qt5XmlPatterns_INCLUDE_DIR} ${Qt5Network_INCLUDE_DIR} ${Qt5Svg_INCLUDE_DIR} ${SRC_PATH}/libMvQtUtil ${SRC_PATH}/libMvQtGui )
    list( APPEND METVIEW_QT_LIBRARIES  MvQtGuiCUI MvQtUtilCUI ${Qt5Widgets_LIBRARIES} ${Qt5Gui_LIBRARIES} ${Qt5Xml_LIBRARIES} ${Qt5XmlPatterns_LIBRARIES} ${Qt5Network_LIBRARIES}  ${Qt5Svg_LIBRARIES})
elseif( METVIEW_QT6)
    list( APPEND METVIEW_QT_INCLUDE_DIRS ${Qt6Widgets_INCLUDE_DIR} ${Qt6Gui_INCLUDE_DIR} ${Qt6Xml_INCLUDE_DIR} ${Qt6Network_INCLUDE_DIR} ${Qt6Svg_INCLUDE_DIR} ${SRC_PATH}/libMvQtUtil ${SRC_PATH}/libMvQtGui )
    list( APPEND METVIEW_QT_LIBRARIES  MvQtGuiCUI MvQtUtilCUI ${Qt6Core5Compat_LIBRARIES} ${Qt6Widgets_LIBRARIES} ${Qt6Gui_LIBRARIES} ${Qt6Xml_LIBRARIES}  ${Qt6Network_LIBRARIES}  ${Qt6Svg_LIBRARIES})
endif()

message(STATUS "CODES_UI METVIEW_EXTRA_LIBRARIES    => ${METVIEW_EXTRA_LIBRARIES}")
message(STATUS "CODES_UI STANDARD_METVIEW_LIBS      => ${STANDARD_METVIEW_LIBS}")
message(STATUS "CODES_UI METVIEW_QT_INCLUDE_DIRS    => ${METVIEW_QT_INCLUDE_DIRS}")


# we need to make sure that
#set(CMAKE_INCLUDE_DIRECTORIES_BEFORE "ON")

set(METVIEW_STANDARD_INCLUDES ${METVIEW_STANDARD_INCLUDE_DIRS})
link_directories( ${CMAKE_CURRENT_SOURCE_DIR}/lib )
message(STATUS "CODES_UI METVIEW_STANDARD_INCLUDE_DIRS  => ${METVIEW_STANDARD_INCLUDES}")


add_definitions( -DR64 -DECCODES_UI -DH_INCLUDES_CC -DUSE_NEW_IO )

# ecbuild automatically test endiness and sets variable EC_BIG_ENDIAN or EC_LITTLE_ENDIAN
if( EC_LITTLE_ENDIAN )
    add_definitions(-DLITTLE_END) # needed for libMars/bufr.h
endif()

# -------------------------
# compiler-specific options
# -------------------------

if     (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" )
    ecbuild_add_cxx_flags("-fpermissive -Wno-write-strings -Wno-deprecated")
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" )
    ecbuild_add_cxx_flags("-fpermissive -Wno-deprecated -undefined dynamic_lookup")
endif()

if     (CMAKE_C_COMPILER_ID STREQUAL "Clang" )
    ecbuild_add_c_flags("-undefined dynamic_lookup")     #  "-fno-common  -mmacosx-version-min=10.8")
endif()

if( EC_OS_NAME MATCHES "windows" )
    # Suppress compiler warnings
    # Suppress warnings about using 'insecure' functions.
    ecbuild_add_cxx_flags("/D_CRT_SECURE_NO_WARNINGS")
    # Suppress warnings about using well-known C functions.
    ecbuild_add_cxx_flags("/D_CRT_NONSTDC_NO_DEPRECATE")
    # Suppress C4267: warns about possible loss of data when converting 'size_t' to 'int'.
    ecbuild_add_cxx_flags("/wd4267")
endif()

set(TAR_ROOT $ENV{TMPDIR}/codes_ui_tar_tmp)
set(NEED_TAR 0)
if(NOT __external_build AND NOT BUILD_WITHIN_METVIEW)
    list( APPEND CPACK_SOURCE_INSTALLED_DIRECTORIES ${TAR_ROOT} .)
    set(NEED_TAR 1)
endif()

macro(add_files_to_tar FILES TAR_DIR)

    if(NEED_TAR)

        message(STATUS "add_files_to_tar()")
        message(STATUS "TAR_DIR=${TAR_DIR}")

        set(tmpdir $ENV{TMPDIR}/codes_ui_tar_tmp/${TAR_DIR})
        message(STATUS "tmpdir=${tmpdir}")

        file(MAKE_DIRECTORY ${tmpdir})
        foreach( f ${FILES} )
            message(STATUS "  file=${f}")
            file(COPY ${f}
                DESTINATION ${tmpdir}
            )
        endforeach()

    endif()

endmacro(add_files_to_tar)

#---------------------------------------
# libCodesUi
#---------------------------------------

set(libCodesUi_srcs_names
    CodesDirHandler.cc
    CodesDirHandler.h
)

foreach( f ${libCodesUi_srcs_names} )
   list(APPEND libCodesUi_srcs ${LIBCODESUI_SRC_PATH}/${f})
endforeach()

ecbuild_add_library( TARGET      CodesUi
                     TYPE        STATIC
                     NOINSTALL
                     SOURCES     ${libCodesUi_srcs}
                     TEMPLATES   ${common_templates}
                     PUBLIC_INCLUDES    ${METVIEW_STANDARD_INCLUDES} ${LOCAL_EXTRA_INCLUDE_DIRS}
                     PUBLIC_LIBS ${METVIEW_EXTRA_LIBRARIES}
)

add_files_to_tar("${libCodesUi_srcs}" "src/libCodesUi")

#---------------------------------------
# libFTimeUtilCUI
#---------------------------------------

set(libFTimeUtilCUI_srcs_names
    fdyntime.cc
    fmettim.cc
    fobject.cc
    fsortabl.cc
    fstatime.cc
    fdyntime.h
    fmettim.h
    fobject.h
    fsortabl.h
    fstatime.h

)

foreach( f ${libFTimeUtilCUI_srcs_names} )
   list(APPEND libFTimeUtilCUI_srcs ${SRC_PATH}/libFTimeUtil/${f})
endforeach()

ecbuild_add_library( TARGET      FTimeUtilCUI
                     TYPE        STATIC
                     NOINSTALL
                     SOURCES     ${libFTimeUtilCUI_srcs}
                     TEMPLATES   ${common_templates}
                     PUBLIC_INCLUDES    ${METVIEW_STANDARD_INCLUDES}
                     PUBLIC_LIBS ${METVIEW_EXTRA_LIBRARIES}
)

add_files_to_tar("${libFTimeUtilCUI_srcs}" "src/libFTimeUtil")

#---------------------------------------
# libMetviewCUI
#---------------------------------------

set(libMetviewCUI_srcs_names
    MvAbstractApplication.cc
    MvLocation.cc
    MvLog.cc
    MvObs.cc
    MvObsSet.cc  
    BufrFilterDef.cc
    BufrFilterEngine.cc
    BufrLocationCollector.cc
    BufrMetaData.cc
    GribMetaData.cc
    LogHandler.cc
    MvBufrEdition.cc
    MvBufrElementTable.cc
    MvEccBufr.cc
    MvException.cc
    MvKeyCondition.cc

=== metview/src/libMvQtTextPager/CMakeLists.txt ===

set(libMvQtTextPager_srcs
    TextPagerCursor.cpp
    TextPagerDocument.cpp
    TextPagerEdit.cpp
    TextPagerLayout_p.cpp
    TextPagerSearchHighlighter.cpp
    TextPagerSearchInterface.cpp
    TextPagerSection.cpp
    TextPagerWidget.cpp
    syntaxhighlighter.cpp)

#if(ECFLOW_QT5)
#    include_directories(${ECFLOW_QT_INCLUDE_DIR})
#else()
#    include(${QT_USE_FILE})
#    set(ECFLOW_QT_LIBRARIES ${QT_LIBRARIES})
#endif()

set(moc_files
    TextPagerCursor_p.hpp
    TextPagerDocument.hpp
    TextPagerDocument_p.hpp
    TextPagerEdit.hpp
    TextPagerEdit_p.hpp
    TextPagerSection_p.hpp
    TextPagerWidget.hpp
    syntaxhighlighter.hpp
)

if(METVIEW_QT5)
 QT5_WRAP_CPP(libMvQtTextPager_MOC ${moc_files})
 #QT5_ADD_RESOURCES(libMvQtTextPager_RES edit.qrc examiner.qrc find.qrc keyDialog.qrc mail.qrc window.qrc)
elseif(METVIEW_QT6)
 QT6_WRAP_CPP(libMvQtTextPager_MOC ${moc_files})
 #QT6_ADD_RESOURCES(libMvQtTextPager_RES edit.qrc examiner.qrc find.qrc keyDialog.qrc mail.qrc window.qrc)
endif()

foreach( f ${generated_srcs} )
    set_source_files_properties( ${f} GENERATED )
endforeach()

ecbuild_add_library( TARGET      MvQtTextPager
                     TYPE        STATIC
                     NOINSTALL
                     SOURCES     ${libMvQtTextPager_MOC} ${libMvQtTextPager_srcs}
                     TEMPLATES   ${common_templates}
                     INCLUDES    ${METVIEW_QT_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR}/../libMvQtGui
                     DEFINITIONS ${METVIEW_EXTRA_DEFINITIONS}
                     DEPENDS     mvmarsxdr
)

=== metview/test/macros/CMakeLists.txt ===
# ------------------------------------------------------------------------
# MACRO metview_etc_files
# Ensures the files listed in ETC_FILES are copied to the build directory
# and that they will be installed at install time
# ------------------------------------------------------------------------

set(POST_INSTALL_TEST_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/metview_post_install_tests.sh)
set(MVRUN "${INSTALLED_METVIEW_STARTUP_SCRIPT}")

macro(metview_macro_test)
    set(options POST_INSTALL)
    set(single_value_args MACRO)
    set(multi_value_args RESOURCES MACRO_ARGS)
    cmake_parse_arguments(_PAR "${options}" "${single_value_args}" "${multi_value_args}" ${_FIRST_ARG} ${ARGN})

    ecbuild_add_test(TARGET ${_PAR_MACRO}.test
        COMMAND ${FULL_STARTUP_SCRIPT_PATH}
        TYPE SCRIPT
        ARGS -nocreatehome -b ${_PAR_MACRO} ${_PAR_MACRO_ARGS}
        RESOURCES ${_PAR_MACRO} ${_PAR_RESOURCES} test_utils.mv hov_utils.mv grib_nearest_utils.mv thermo_parcel_utils.mv )

    # add to the post-install tests too
    if(_PAR_POST_INSTALL)
        string(REPLACE ";" " " MACRO_ARGS "${_PAR_MACRO_ARGS}") # ';' -> ' '
        file(APPEND ${POST_INSTALL_TEST_SCRIPT} "${MVRUN} -b ${_PAR_MACRO} ${MACRO_ARGS}\n")
    endif()

    set(all_tests "${all_tests}${_PAR_MACRO} ") # note the spacing
endmacro()

# write the start of the post-install test script
file(WRITE ${POST_INSTALL_TEST_SCRIPT} "#!/bin/sh\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# Run the tests on the installed version of Metview\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# -------------------------------------------------\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "set -eax\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")

set(all_tests) # empty to start with

if(ENABLE_PLOTTING)
    metview_macro_test(MACRO HelloWorld.mv
        RESOURCES set_output.mv ../data/z500.grb
        POST_INSTALL)

    metview_macro_test(MACRO layoutx3.mv
        RESOURCES set_output.mv ../data/z500.grb)

    metview_macro_test(MACRO plot_from_read_grib.mv
        RESOURCES set_output.mv ../data/fc_data.grib)

    metview_macro_test(MACRO plot_bufr.mv
        RESOURCES set_output.mv ../data/temp_10.bufr)
endif()

if(NOT ENABLE_PLOTTING)
    metview_macro_test(MACRO no_plotting.mv
        POST_INSTALL)
endif()

metview_macro_test(MACRO grib_dates.mv
    RESOURCES ../data/fc_data.grib
    ../data/hindcast.grib
    ../data/fc_long_step.grib
    ../data/monthly_avg.grib
    ../data/flexpart_minute_step.grib
    ../data/step_60m.grib
    POST_INSTALL)

metview_macro_test(MACRO grib_keys.mv
    RESOURCES ../data/fc_data.grib
    ../data/lnsp.grib
    ../data/xs_rgg_input.grib
    POST_INSTALL)

metview_macro_test(MACRO grib_gradient.mv
    RESOURCES ../data/grad_input_global.grib
    ../data/grad_ref_global.grib
    ../data/grad_input_global_sn.grib
    ../data/grad_ref_global_sn.grib
    ../data/u_sn_reg_ll.grib
    ../data/grad_ref_u_sn.grib
    ../data/second_deriv_input_global.grib
    ../data/second_deriv_ref_global.grib
    ../data/div_vor_ref.grib
    ../data/laplace_ref.grib
    POST_INSTALL)

metview_macro_test(MACRO grib_gradient_analytic.mv
    RESOURCES ../data/grad_input_global.grib)

metview_macro_test(MACRO qg_meteo.mv
    RESOURCES ../data/geostrophic.grib
    ../data/tz_1x1_na.grib
    ../data/static_stability_ref.grib
    ../data/q_vector_ref.grib)

metview_macro_test(MACRO grib_integral.mv
    RESOURCES ../data/t1000_LL_2x2.grb
    ../data/LL_2x2_cellarea_ref.grib
    ../data/t1000_reg_gg_N48.grib
    ../data/t1000_red_gg_N48.grib
    ../data/rgg_small_subarea.grib
    ../data/reg_gg_N48_cellarea_ref.grib
    ../data/red_gg_N48_cellarea_ref.grib
    ../data/rgg_O1280_subarea.grib
    ../data/rgg_small_subarea_cellarea_ref.grib)

metview_macro_test(MACRO grib_nearest_ll.mv
    RESOURCES ../data/bufr_picker_reference.gpt
    ../data/nearest_gridpoint_gpt_ref_1.gpt
    ../data/t1000_LL_1x1.grb
    ../data/t1000_LL_1x1_subarea.grb
    ../data/t1000_LL_1x1_subarea_g2.grb
    ../data/t1000_LL_2x2.grb
    ../data/t1000_LL_2x2_with_missing.grb
    ../data/nearest_gridpoint_gpt_ref_missing_1.gpt
    ../data/nearest_gridpoint_gpt_ref_missing_1.gpt
    ../data/nearest_gridpoint_gpt_ref_missing_2.gpt
    ../data/nearest_gridpoint_gpt_ref_missing_2.gpt
    ../data/ll_no_pole.grib
    ../data/z500.grb
    ../data/z500_g2.grb)

metview_macro_test(MACRO grib_nearest_reduced_ll.mv
    RESOURCES ../data/reduced_ll.grib
    )

metview_macro_test(MACRO grib_nearest_reduced_gg.mv
    RESOURCES
    ../data/t1000_SH_to_RGG_reference.grb
    ../data/t1000_SH_to_RGG_reference_g2.grb
    ../data/t1000_red_gg_N48.grib
    ../data/rgg_western_subarea.grib
    ../data/rgg_western_subarea_g2.grib
    ../data/rgg_small_subarea.grib
    ../data/rgg_zero_lon_subarea.grib
    ../data/rgg_zero_lon_subarea_g2.grib
    )

metview_macro_test(MACRO grib_nearest_regular_gg.mv
    RESOURCES
    ../data/regular_gaussian_subarea.grib
    ../data/regular_gaussian_subarea_g2.grib
    ../data/t1000_reg_gg_N48.grib
)

metview_macro_test(MACRO grib_nearest_healpix.mv
    RESOURCES ../data/t2m_healpix_4.grib
    )

metview_macro_test(MACRO grib_vertical_geopot_on_ml.mv
    RESOURCES ../data/tq_ml137.grib
    ../data/z_ml137_ref.grib
    )

metview_macro_test(MACRO grib_vertical_integral.mv
    RESOURCES ../data/t_lnsp_ml137.grb
    ../data/univertint_ml_ref.grib
    ../data/univertint_pl_ref.grib
    ../data/t_80Pa.grib
    ../data/vertint_ref.grib
    ../data/tuv_pl.grib
     )

 metview_macro_test(MACRO grib_vertical_interpolate_to_pl.mv
     RESOURCES ../data/tq_ml137.grib
     ../data/ml2pl_ref.grib
     ../data/xs_pl_input.grib
     ../data/pl_to_pl_ref.grib
     ../data/pl_to_pl_log_ref.grib
     ../data/pl_pa_hpa.grib
     )

 metview_macro_test(MACRO grib_vertical_interpolate_to_hl_1.mv
     RESOURCES ../data/tq_ml137.grib
      ../data/z_ml137_ref.grib
      ../data/ml_to_hl_asl_ref.grib
      ../data/ml_to_hl_agr_ref.grib
      ../data/ml_to_hl_log_asl_ref.grib
      ../data/ml_to_hl_log_agr_ref.grib
     )


 metview_macro_test(MACRO grib_vertical_interpolate_to_hl_2.mv
     RESOURCES ../data/tq_ml137.grib
     ../data/z_ml137_ref.grib
     ../data/ml_to_hl_asl_ref.grib
     ../data/ml_to_hl_agr_ref.grib
     ../data/ml_to_hl_agr_surf_ref.grib
     ../data/ml_to_hl_agr_log_surf_ref.grib
     )

metview_macro_test(MACRO grib_vertical_pressure.mv
    RESOURCES ../data/t_lnsp_ml137.grb
    ../data/tuv_pl.grib
    ../data/thickness_ml137.grib
    ../data/pres_ml137.grib
    ../data/dt_dp_ref.grib
    ../data/omega_ml.grib
    ../data/omega_pl.grib
    )

metview_macro_test(MACRO polygon_mask.mv
    RESOURCES ../data/poly_ref.grib
    ../data/poly_multi_ref.grib)

metview_macro_test(MACRO interpolation_sh_to_ll.mv
    RESOURCES ../data/t1000_SH.grb
    POST_INSTALL)

metview_macro_test(MACRO interpolation_sh_to_rgg.mv
    RESOURCES ../data/t1000_SH.grb)

metview_macro_test(MACRO interpolation_rgg_to_ll.mv
    RESOURCES ../data/t1000_SH_to_RGG_reference.grb)

metview_macro_test(MACRO interp_default.mv
    RESOURCES ../data/t1000_SH_to_RGG_reference.grb)

if(HAVE_PPROC_EMOS AND HAVE_PPROC_MIR)
    metview_macro_test(MACRO interp_emos.mv
        RESOURCES ../data/t1000_SH_to_RGG_reference.grb)
endif()

if(HAVE_PPROC_MIR)
    metview_macro_test(MACRO interp_mir.mv
        RESOURCES ../data/t1000_SH_to_RGG_reference.grb)
endif()

metview_macro_test(MACRO grib_to_gpt.mv
    RESOURCES ../data/t1000_LL_2x2.grb
    ../data/gpt_to_grib_nearest_sum_reference.grb
    ../data/mercator.grib
    POST_INSTALL)

metview_macro_test(MACRO gpt_to_grib_core.mv
    RESOURCES ../data/gpt_to_grib_input_1.gpt
    ../data/gpt_to_grib_reciprocal_reference.grb
    ../data/gpt_to_grib_exp_mean_reference.grb
    ../data/gpt_to_grib_exp_sum_reference.grb
    POST_INSTALL)

metview_macro_test(MACRO gpt_to_grib_with_template.mv
    RESOURCES ../data/t1000_LL_2x2.grb ../data/10U_GG.grb)

metview_macro_test(MACRO gpt_to_grib_nearest.mv
    RESOURCES ../data/t1000_LL_7x7.grb
    ../data/example_XYLDTZ.geo
    ../data/example_XYLDTZ_with_missing.geo
    ../data/gpt_to_grib_nearest_sum_reference.grb
    ../data/gpt_to_grib_nearest_sum_missing_reference.grb
    ../data/gpt_to_grib_nearest_mean_reference.grb
    ../data/gpt_to_grib_nearest_mean_missing_reference.grb
    ../data/gpt_to_grib_nearest_count_reference.grb
    ../data/nearest_gridpoint_gpt_ref_1.gpt)

metview_macro_test(MACRO geopoint_types.mv
    RESOURCES ../data/bufr_obs_filter_basic_reference.gpt
    ../data/example_POLAR_VECTOR.geo
    ../data/example_XYZ.geo
    ../data/example_XY_VECTOR.geo)

metview_macro_test(MACRO gpt_set.mv
    RESOURCES ../data/gpt_to_grib_input_1.gpt
    ../data/bufr_picker_reference.gpt
    ../data/bufr_obs_filter_area_reference.gpt
    ../data/bufr_obs_filter_custom_reference.gpt
    ../data/nearest_gridpoint_gpt_ref_1.gpt
    ../data/t1000_LL_1x1.grb
    ../data/hindcast.grib)

# metview_macro_test(MACRO     interpolation_gg_to_subarea.mv
# RESOURCES  ../data/10U_GG.grb)
metview_macro_test(MACRO bufr_obs_filter.mv
    RESOURCES ../data/bufr-3.bufr
    ../data/compress_3.bufr
    ../data/bufr_obs_filter_basic_reference.gpt
    ../data/temp_10.bufr
    ../data/bufr_obs_filter_level_reference.gpt
    ../data/synop_multi_subset_uncompressed.bufr
    ../data/bufr_obs_filter_area_reference.gpt
    ../data/bufr_obs_filter_missvals_1_reference.gpt
    ../data/bufr_obs_filter_missvals_2_reference.gpt
    ../data/amsua_13.bufr
    ../data/bufr_obs_filter_time_reference.gpt
    ../data/bufr_obs_filter_custom_reference.gpt
    ../data/bufr_obs_filter_blockstation_reference.gpt
    ../data/aircraft_10.bufr
    ../data/trop1.bufr
    ../data/bufr_obs_filter_descriptor_string_reference.gpt
    ../data/bufr_obs_filter_subtype_reference.gpt
    ../data/temp_small.bufr
    ../data/bufr_obs_filter_ncols_reference.gpt
    ../data/bufr_obs_filter_ncols_miss_reference.gpt
    ../data/missing_ident.bufr
    ../data/stnid_with_internal_spaces.bufr
    ../data/bufr_obs_filter_ncols_stnids_spaces_reference.gpt
    ../data/ssd_missing_location.bufr
    ../data/ssd_missing_location_ref.gpt
)

metview_macro_test(MACRO bufr_picker.mv
    RESOURCES ../data/temp_10.bufr ../data/bufr_picker_reference_ws.gpt
    ../data/cape-ens.bufr ../data/bufr_picker_two_coordinate_descriptors_compressed_reference.gpt
    ../data/2t-ens.bufr ../data/bufr_picker_two_coordinate_descriptors_uncompressed_reference.gpt
    ../data/temp_small.bufr ../data/bufr_picker_ncols_reference.gpt
    POST_INSTALL)

if(ENABLE_UI)
    metview_macro_test(MACRO bufr_filter.mv
        RESOURCES ../data/temp_small.bufr ../data/aircraft_small.bufr
        ../data/ens_multi_subset_uncompressed.bufr
        ../data/ens_multi_subset_compressed.bufr
        ../data/synop_multi_subset_uncompressed.bufr
        ../data/tropical_cyclone.bufr
        ../data/wave_uncompressed.bufr
        ../data/compress_3.bufr
        ../data/stnid_with_internal_spaces.bufr
        ../data/syn_new.bufr)
endif()

metview_macro_test(MACRO inline_c.mv
    RESOURCES ../data/z500.grb
    POST_INSTALL)

if(HAVE_METVIEW_FORTRAN)
    metview_macro_test(MACRO inline_fortran.mv
        RESOURCES ../data/z500.grb
        POST_INSTALL)

    metview_macro_test(MACRO spectra.mv
        RESOURCES ../data/z_for_spectra.grib
        POST_INSTALL)

    metview_macro_test(MACRO pottf.mv
        RESOURCES ../data/thermo_profile.grib
        ../data/theta_input_pl.grib
        ../data/theta_pl_ref.grib
        ../data/theta_ml_ref.grib)
endif()

metview_macro_test(MACRO station.mv
    POST_INSTALL)

metview_macro_test(MACRO unix.mv)

metview_macro_test(MACRO vectors.mv
    RESOURCES ../data/gpt_to_grib_nearest_sum_reference.grb
    ../data/bufr_picker_reference.gpt
    POST_INSTALL)

metview_macro_test(MACRO tables.mv
    RESOURCES ../data/table1.csv
    ../data/table2.csv
    ../data/example_XYLDTZ.geo
    ../data/csv_from_windows_1.csv)

=== mir/etc/mir/CMakeLists.txt ===
file(GLOB config_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.yaml")

install(
    FILES       ${config_files}
    DESTINATION "etc/mir"
    PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

foreach(_f ${config_files})
    configure_file(${_f} "${CMAKE_BINARY_DIR}/etc/mir/${_f}" COPYONLY)
endforeach()

=== mir/share/mir/CMakeLists.txt ===
add_subdirectory(masks)

=== mir/src/mir/CMakeLists.txt ===
### system headers

include(CheckCSourceCompiles)

check_c_source_compiles("
#include <sys/stat.h>
int main() {
    struct stat s;
    s.st_ctimespec;
    return 0;
}"
HAS_SYS_STAT_ST_CTIMESPEC)

### config headers

ecbuild_generate_config_headers(DESTINATION ${INSTALL_INCLUDE_DIR}/mir)

configure_file(api/mir_config.h.in api/mir_config.h)
configure_file(api/mir_version.h.in api/mir_version.h)
configure_file(api/mir_version.cc.in api/mir_version.cc)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/api/mir_config.h ${CMAKE_CURRENT_BINARY_DIR}/api/mir_version.h
    DESTINATION ${INSTALL_INCLUDE_DIR}/mir/api)


unset(mir_srcs)
list(APPEND mir_srcs

    ${CMAKE_CURRENT_BINARY_DIR}/api/mir_version.cc

    action/area/Area.cc
    action/area/Area.h
    action/area/AreaCropper.cc
    action/area/AreaCropper.h
    action/area/AreaMasker.cc
    action/area/AreaMasker.h
    action/calc/FormulaAction.cc
    action/calc/FormulaAction.h
    action/context/Context.cc
    action/context/Context.h
    action/filter/AddRandomFilter.cc
    action/filter/AddRandomFilter.h
    action/filter/AdjustWindsDirections.cc
    action/filter/AdjustWindsDirections.h
    action/filter/AdjustWindsScaleCosLatitude.cc
    action/filter/AdjustWindsScaleCosLatitude.h
    action/filter/Bandpass.cc
    action/filter/Bandpass.h
    action/filter/BitmapFilter.cc
    action/filter/BitmapFilter.h
    action/filter/CesaroSummationFilter.cc
    action/filter/CesaroSummationFilter.h
    action/filter/FrameFilter.cc
    action/filter/FrameFilter.h
    action/filter/GlobaliseFilter.cc
    action/filter/GlobaliseFilter.h
    action/filter/NablaFilter.cc
    action/filter/NablaFilter.h
    action/filter/ShTruncate.cc
    action/filter/ShTruncate.h
    action/filter/StatisticsFilter.cc
    action/filter/StatisticsFilter.h
    action/filter/UnstructuredFilter.cc
    action/filter/UnstructuredFilter.h
    action/interpolate/Gridded2GridDef.cc
    action/interpolate/Gridded2GridDef.h
    action/interpolate/Gridded2GriddedInterpolation.cc
    action/interpolate/Gridded2GriddedInterpolation.h
    action/interpolate/Gridded2NamedGrid.cc
    action/interpolate/Gridded2NamedGrid.h
    action/interpolate/Gridded2OctahedralGG.cc
    action/interpolate/Gridded2OctahedralGG.h
    action/interpolate/Gridded2Points.cc
    action/interpolate/Gridded2Points.h
    action/interpolate/Gridded2ReducedGG.cc
    action/interpolate/Gridded2ReducedGG.h
    action/interpolate/Gridded2ReducedGGPLGiven.cc
    action/interpolate/Gridded2ReducedGGPLGiven.h
    action/interpolate/Gridded2ReducedLL.cc
    action/interpolate/Gridded2ReducedLL.h
    action/interpolate/Gridded2ReducedLLPLGiven.cc
    action/interpolate/Gridded2ReducedLLPLGiven.h
    action/interpolate/Gridded2RegularGG.cc
    action/interpolate/Gridded2RegularGG.h
    action/interpolate/Gridded2RegularLL.cc
    action/interpolate/Gridded2RegularLL.h
    action/interpolate/Gridded2RotatedGrid.cc
    action/interpolate/Gridded2RotatedGrid.h
    action/interpolate/Gridded2RotatedLL.cc
    action/interpolate/Gridded2RotatedLL.h
    action/interpolate/Gridded2RotatedNamedGrid.cc
    action/interpolate/Gridded2RotatedNamedGrid.h
    action/interpolate/Gridded2RotatedOctahedralGG.cc
    action/interpolate/Gridded2RotatedOctahedralGG.h
    action/interpolate/Gridded2RotatedReducedGG.cc
    action/interpolate/Gridded2RotatedReducedGG.h
    action/interpolate/Gridded2RotatedReducedGGPLGiven.cc
    action/interpolate/Gridded2RotatedReducedGGPLGiven.h
    action/interpolate/Gridded2RotatedRegularGG.cc
    action/interpolate/Gridded2RotatedRegularGG.h
    action/interpolate/Gridded2TypedGrid.cc
    action/interpolate/Gridded2TypedGrid.h
    action/interpolate/Gridded2UnrotatedGrid.cc
    action/interpolate/Gridded2UnrotatedGrid.h
    action/io/Copy.cc
    action/io/Copy.h
    action/io/EndAction.cc
    action/io/EndAction.h
    action/io/Save.cc
    action/io/Save.h
    action/io/Set.cc
    action/io/Set.h
    action/misc/CheckerBoard.cc
    action/misc/CheckerBoard.h
    action/misc/Noop.cc
    action/misc/Noop.h
    action/misc/ReferencePattern.cc
    action/misc/ReferencePattern.h
    action/misc/ResetMissingValues.cc
    action/misc/ResetMissingValues.h
    action/misc/SelectField.cc
    action/misc/SelectField.h
    action/misc/SetMetadata.cc
    action/misc/SetMetadata.h
    action/plan/Action.cc
    action/plan/Action.h
    action/plan/ActionGraph.cc
    action/plan/ActionGraph.h
    action/plan/ActionNode.cc
    action/plan/ActionNode.h
    action/plan/ActionPlan.cc
    action/plan/ActionPlan.h
    action/plan/Executor.cc
    action/plan/Executor.h
    action/plan/Job.cc
    action/plan/Job.h
    action/plan/SimpleExecutor.cc
    action/plan/SimpleExecutor.h
    action/plan/ThreadExecutor.cc
    action/plan/ThreadExecutor.h
    api/MIRComplexJob.cc
    api/MIRComplexJob.h
    api/MIREstimation.h
    api/MIRJob.cc
    api/MIRJob.h
    api/MIRWatcher.cc
    api/MIRWatcher.h
    caching/AreaCacheEntry.cc
    caching/AreaCacheEntry.h
    caching/AreaCropperCache.cc
    caching/AreaCropperCache.h
    caching/AreaMaskerCache.cc
    caching/AreaMaskerCache.h
    caching/InMemoryCache.cc
    caching/InMemoryCache.h
    caching/InMemoryCacheBase.cc
    caching/InMemoryCacheBase.h
    caching/InMemoryCacheStatistics.cc
    caching/InMemoryCacheStatistics.h
    caching/InMemoryCacheUsage.cc
    caching/InMemoryCacheUsage.h
    caching/MeshCache.cc
    caching/MeshCache.h
    caching/SharedMemoryKey.cc
    caching/SharedMemoryKey.h
    caching/WeightCache.cc
    caching/WeightCache.h
    caching/legendre/LegendreLoader.cc
    caching/legendre/LegendreLoader.h
    caching/matrix/FileLoader.cc
    caching/matrix/FileLoader.h
    caching/matrix/MatrixLoader.cc
    caching/matrix/MatrixLoader.h
    caching/matrix/SharedMemoryLoader.cc
    caching/matrix/SharedMemoryLoader.h
    compare/BufrField.cc
    compare/BufrField.h
    compare/Field.cc
    compare/Field.h
    compare/FieldComparator.cc
    compare/FieldComparator.h
    compare/FieldInfo.cc
    compare/FieldInfo.h
    compare/FieldSet.cc
    compare/FieldSet.h
    compare/GribField.cc
    compare/GribField.h
    compare/MultiFile.cc
    compare/MultiFile.h
    compat/GribCompatibility.cc
    compat/GribCompatibility.h
    config/LibMir.cc
    config/LibMir.h
    data/CartesianVector2DField.cc
    data/CartesianVector2DField.h
    data/Field.cc
    data/Field.h
    data/MIRField.cc
    data/MIRField.h
    data/MIRFieldStats.cc
    data/MIRFieldStats.h
    data/Space.cc
    data/Space.h
    data/space/Space1DAngleT.cc
    data/space/Space1DAngleT.h
    data/space/Space1DLinear.cc
    data/space/Space1DLinear.h
    data/space/Space2DVectorZonalMeridional.cc
    data/space/Space2DVectorZonalMeridional.h
    data/space/Space3DCartesian.cc
    data/space/Space3DCartesian.h
    data/space/Space3DVectorZonalMeridionalVertical.cc
    data/space/Space3DVectorZonalMeridionalVertical.h
    data/space/SpaceLinear.cc
    data/space/SpaceLinear.h
    data/space/SpaceLogarithmic.cc
    data/space/SpaceLogarithmic.h
    grib/BasicAngle.cc
    grib/BasicAngle.h
    grib/Packing.cc
    grib/Packing.h
    grib/Config.cc
    grib/Config.h
    input/ArtificialInput.cc
    input/ArtificialInput.h
    input/ConstantInput.cc
    input/ConstantInput.h
    input/DistributionInput.cc
    input/DistributionInput.h
    input/DummyInput.cc
    input/DummyInput.h
    input/EmptyInput.cc
    input/EmptyInput.h
    input/GeoPointsFileInput.cc
    input/GeoPointsFileInput.h
    input/GribAllFileInput.cc
    input/GribAllFileInput.h
    input/GribDataHandleInput.cc
    input/GribDataHandleInput.h
    input/GribFileInput.cc
    input/GribFileInput.h
    input/GribInput.cc
    input/GribInput.h
    input/GribMemoryInput.cc
    input/GribMemoryInput.h
    input/GribStreamInput.cc
    input/GribStreamInput.h
    input/MIRInput.cc
    input/MIRInput.h
    input/MultiDimensionalGribFileInput.cc
    input/MultiDimensionalGribFileInput.h
    input/MultiDimensionalInput.cc
    input/MultiDimensionalInput.h
    input/MultiStreamInput.cc
    input/MultiStreamInput.h
    input/RawInput.cc
    input/RawInput.h
    input/VectorInput.cc
    input/VectorInput.h
    iterator/UnstructuredIterator.h
    iterator/detail/RegularIterator.cc
    iterator/detail/RegularIterator.h
    key/Area.cc
    key/Area.h
    key/Key.cc
    key/Key.h
    key/grid/ClassicPattern.cc
    key/grid/ClassicPattern.h
    key/grid/Grid.cc
    key/grid/Grid.h
    key/grid/GridPattern.cc
    key/grid/GridPattern.h
    key/grid/NamedClassic.cc
    key/grid/NamedClassic.h
    key/grid/NamedFromFile.cc
    key/grid/NamedFromFile.h
    key/grid/NamedGrid.h
    key/grid/NamedOctahedral.cc
    key/grid/NamedOctahedral.h
    key/grid/NamedRegular.cc
    key/grid/NamedRegular.h
    key/grid/OctahedralPattern.cc
    key/grid/OctahedralPattern.h
    key/grid/RegularLL.cc
    key/grid/RegularLL.h
    key/grid/RegularLLPattern.cc
    key/grid/RegularLLPattern.h
    key/grid/RegularPattern.cc
    key/grid/RegularPattern.h
    key/grid/TypedGrid.cc
    key/grid/TypedGrid.h
    key/intgrid/Automatic.cc
    key/intgrid/Automatic.h
    key/intgrid/Intgrid.cc
    key/intgrid/Intgrid.h
    key/intgrid/NamedGrid.cc
    key/intgrid/NamedGrid.h
    key/intgrid/None.cc
    key/intgrid/None.h
    key/intgrid/Source.cc
    key/intgrid/Source.h
    key/resol/Resol.cc
    key/resol/Resol.h
    key/style/CustomParametrisation.cc
    key/style/CustomParametrisation.h
    key/style/CustomStyle.cc
    key/style/CustomStyle.h
    key/style/ECMWFStyle.cc
    key/style/ECMWFStyle.h
    key/style/MIRStyle.cc
    key/style/MIRStyle.h
    key/truncation/Automatic.cc
    key/truncation/Automatic.h
    key/truncation/None.cc
    key/truncation/None.h
    key/truncation/Ordinal.cc
    key/truncation/Ordinal.h
    key/truncation/Truncation.cc
    key/truncation/Truncation.h
    lsm/FileLSM.cc
    lsm/FileLSM.h
    lsm/GribFileMask.cc
    lsm/GribFileMask.h
    lsm/GribFileMaskFromMIR.cc
    lsm/GribFileMaskFromMIR.h
    lsm/GribFileMaskFromUser.cc
    lsm/GribFileMaskFromUser.h
    lsm/LSMSelection.cc
    lsm/LSMSelection.h
    lsm/LandSeaMasks.cc
    lsm/LandSeaMasks.h
    lsm/MappedMask.cc
    lsm/MappedMask.h
    lsm/Mask.cc
    lsm/Mask.h
    lsm/NamedLSM.cc
    lsm/NamedLSM.h
    lsm/NoMask.cc
    lsm/NoMask.h
    lsm/NoneLSM.cc
    lsm/NoneLSM.h
    lsm/TenMinutesMask.cc
    lsm/TenMinutesMask.h
    method/Cropping.cc
    method/Cropping.h
    method/FailMethod.cc
    method/FailMethod.h
    method/MatrixCacheCreator.cc
    method/MatrixCacheCreator.h
    method/Method.cc
    method/Method.h
    method/MethodWeighted.cc
    method/MethodWeighted.h
    method/WeightMatrix.cc
    method/WeightMatrix.h
    method/gridbox/GridBoxAverage.cc
    method/gridbox/GridBoxAverage.h
    method/gridbox/GridBoxMethod.cc
    method/gridbox/GridBoxMethod.h
    method/gridbox/GridBoxStatistics.cc
    method/gridbox/GridBoxStatistics.h
    method/knn/KNearest.cc
    method/knn/KNearest.h
    method/knn/KNearestNeighbours.cc
    method/knn/KNearestNeighbours.h
    method/knn/KNearestStatistics.cc
    method/knn/KNearestStatistics.h
    method/knn/NearestLSM.cc
    method/knn/NearestLSM.h
    method/knn/NearestNeighbour.cc
    method/knn/NearestNeighbour.h
    method/knn/distance/ClimateFilter.cc
    method/knn/distance/ClimateFilter.h
    method/knn/distance/Cressman.cc
    method/knn/distance/Cressman.h
    method/knn/distance/DistanceWeighting.cc
    method/knn/distance/DistanceWeighting.h
    method/knn/distance/DistanceWeightingWithLSM.cc
    method/knn/distance/DistanceWeightingWithLSM.h
    method/knn/distance/GaussianDistanceWeighting.cc
    method/knn/distance/GaussianDistanceWeighting.h
    method/knn/distance/InverseDistanceWeighting.cc
    method/knn/distance/InverseDistanceWeighting.h
    method/knn/distance/InverseDistanceWeightingSquared.cc
    method/knn/distance/InverseDistanceWeightingSquared.h
    method/knn/distance/NearestLSM.cc

=== debian/changelog ===
metview (5.21.2-1build3) noble; urgency=medium

  * No-change rebuild against libqt6core6t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Apr 2024 01:15:27 +0100

metview (5.21.2-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:06:11 +0000

metview (5.21.2-1build1) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:09:42 +0000

metview (5.21.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 01 Mar 2024 08:57:29 +0000

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  ecbuild (>= 3.3.0-2),
  gfortran | fortran-compiler, 
  python3-all-dev,
  libgeotiff-dev,
  flex, 
  bison, 
  libtirpc-dev,
  libncurses-dev,
  libjemalloc-dev,
  libpng-dev,
  libssl-dev,
  libhdf5-dev, 
  liblapack-dev,
  libpango1.0-dev, 
  libmetkit-dev,
  libmetkit-utils,
  fdb5,
  libfdb5-dev (>= 5.11.25~),
  odc,
  libodc-dev,
  libfftw3-dev,
  libeigen3-dev,
  chrpath, 
  mksh,
  libfckit-dev,
  qt6-base-dev,
  libqt6core5compat6-dev,
  libqt6svg6-dev,
  libvulkan-dev,
  libxkbcommon-dev,
  libemos-dev, libemos-bin,
  libeccodes-dev (>= 2.22.0),
  libeccodes-tools,
  libatlas-ecmwf-dev (>= 0.29.0-2), 
  libatlas-ecmwf-utils,
  libeckit-dev (>= 1.10.1~),
  libboost-dev, libopenjp2-7-dev,
  libmagics++-metview-dev (>= 4.12.1-2), 
  libmagics++-dev (>= 4.12.1-2),
  libxmu-dev, libgdbm-dev, 
  libcurl4-gnutls-dev,
  libcairo2-dev, 
  pkgconf,
  swig, 
  libexpat1-dev,
  libterralib-dev (>= 4.3.0+dfsg.2-8), 
  libqt5svg5-dev,
  libgd-dev, 
  imagemagick, 
  libnetcdf-dev, 
  flextra, 
  flexpart
Standards-Version: 4.6.2
Homepage: https://confluence.ecmwf.int/display/METV/Metview
Vcs-Browser: https://salsa.debian.org:/science-team/metview.git
Vcs-Git: https://salsa.debian.org:/science-team/metview.git

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetview0d (=${binary:Version}),
 x11-utils, metview-data, python3
Recommends: magics++, flextra, flexpart
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview0d
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: libs
Description: Shared libraries  for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides shared libraries and  for  Metview-based software.

Package: libmetview-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmetview0d (=${binary:Version}), 
 libxxhash-dev, libsnappy-dev, liblz4-dev, libbz2-dev
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.
